--- u-boot-2011.06_original/include/command.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/include/command.h	2014-07-29 17:28:38.819972000 +0800
@@ -101,6 +101,12 @@
 extern int do_bootm(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
 extern int do_reset(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
 
+enum command_ret_t {
+	CMD_RET_SUCCESS,	/* 0 = Success */
+	CMD_RET_FAILURE,	/* 1 = Failure */
+	CMD_RET_USAGE = -1,	/* Failure, please report 'usage' error */
+};
+
 #endif	/* __ASSEMBLY__ */
 
 /*
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/common.h u-boot-2011.06/include/common.h
--- u-boot-2011.06_original/include/common.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/include/common.h	2015-05-29 14:14:51.790650000 +0800
@@ -34,6 +34,23 @@
 typedef volatile unsigned short vu_short;
 typedef volatile unsigned char	vu_char;
 
+typedef int          Int32;
+typedef unsigned int UInt32;
+
+typedef short          Int16;
+typedef unsigned short UInt16;
+
+typedef char          Int8;
+typedef unsigned char UInt8;
+typedef unsigned char byte;
+
+#ifndef	BOOL_WAS_DEFINED
+#define BOOL_WAS_DEFINED
+typedef unsigned int bool;
+#endif
+
+
+
 #include <config.h>
 #include <asm-offsets.h>
 #include <linux/bitops.h>
@@ -112,6 +129,13 @@
 #include <asm/arch/hardware.h>
 #endif
 
+#ifdef CONFIG_SPI_FLASH_CNC1800L
+#include <cnc1800l_spi.h>
+#endif
+#ifdef CONFIG_SPI_FLASH_CNC1900
+#include <cnc1900_spi.h>
+#endif
+
 #include <part.h>
 #include <flash.h>
 #include <image.h>
@@ -192,6 +216,48 @@
 #define MIN(x, y)  min(x, y)
 #define MAX(x, y)  max(x, y)
 
+#define min3(X, Y, Z)				\
+	({ typeof(X) __x = (X);			\
+		typeof(Y) __y = (Y);		\
+		typeof(Z) __z = (Z);		\
+		__x < __y ? (__x < __z ? __x : __z) :	\
+		(__y < __z ? __y : __z); })
+
+#define max3(X, Y, Z)				\
+	({ typeof(X) __x = (X);			\
+		typeof(Y) __y = (Y);		\
+		typeof(Z) __z = (Z);		\
+		__x > __y ? (__x > __z ? __x : __z) :	\
+		(__y > __z ? __y : __z); })
+
+#define MIN3(x, y, z)  min3(x, y, z)
+#define MAX3(x, y, z)  max3(x, y, z)
+
+/*
+ * Return the absolute value of a number.
+ *
+ * This handles unsigned and signed longs, ints, shorts and chars.  For all
+ * input types abs() returns a signed long.
+ *
+ * For 64-bit types, use abs64()
+ */
+#define abs(x) ({						\
+		long ret;					\
+		if (sizeof(x) == sizeof(long)) {		\
+			long __x = (x);				\
+			ret = (__x < 0) ? -__x : __x;		\
+		} else {					\
+			int __x = (x);				\
+			ret = (__x < 0) ? -__x : __x;		\
+		}						\
+		ret;						\
+	})
+
+#define abs64(x) ({				\
+		s64 __x = (x);			\
+		(__x < 0) ? -__x : __x;		\
+	})
+
 #if defined(CONFIG_ENV_IS_EMBEDDED)
 #define TOTAL_MALLOC_LEN	CONFIG_SYS_MALLOC_LEN
 #elif ( ((CONFIG_ENV_ADDR+CONFIG_ENV_SIZE) < CONFIG_SYS_MONITOR_BASE) || \
@@ -610,9 +676,14 @@
 ulong	video_setmem (ulong);
 
 /* arch/$(ARCH)/lib/cache.c */
+void	enable_caches(void);
 void	flush_cache   (unsigned long, unsigned long);
+void	flush_dcache_all(void);
 void	flush_dcache_range(unsigned long start, unsigned long stop);
 void	invalidate_dcache_range(unsigned long start, unsigned long stop);
+void	invalidate_dcache_all(void);
+void	invalidate_icache_all(void);
+
 
 
 /* arch/$(ARCH)/lib/ticks.S */
@@ -644,6 +715,7 @@
 
 /* lib/time.c */
 void	udelay        (unsigned long);
+void mdelay(unsigned long);
 
 /* lib/vsprintf.c */
 ulong	simple_strtoul(const char *cp,char **endp,unsigned int base);
@@ -751,7 +823,7 @@
 
 #define ARRAY_SIZE(x) (sizeof(x) / sizeof((x)[0]))
 
-#define ROUND(a,b)		(((a) + (b)) & ~((b) - 1))
+#define ROUND(a,b)		(((a) + (b) - 1) & ~((b) - 1))
 #define DIV_ROUND(n,d)		(((n) + ((d)/2)) / (d))
 #define DIV_ROUND_UP(n,d)	(((n) + (d) - 1) / (d))
 #define roundup(x, y)		((((x) + ((y) - 1)) / (y)) * (y))
@@ -759,4 +831,91 @@
 #define ALIGN(x,a)		__ALIGN_MASK((x),(typeof(x))(a)-1)
 #define __ALIGN_MASK(x,mask)	(((x)+(mask))&~(mask))
 
+/*
+ * ARCH_DMA_MINALIGN is defined in asm/cache.h for each architecture.  It
+ * is used to align DMA buffers.
+ */
+#ifndef __ASSEMBLY__
+#include <asm/cache.h>
+#endif
+
+/*
+ * The ALLOC_CACHE_ALIGN_BUFFER macro is used to allocate a buffer on the
+ * stack that meets the minimum architecture alignment requirements for DMA.
+ * Such a buffer is useful for DMA operations where flushing and invalidating
+ * the cache before and after a read and/or write operation is required for
+ * correct operations.
+ *
+ * When called the macro creates an array on the stack that is sized such
+ * that:
+ *
+ * 1) The beginning of the array can be advanced enough to be aligned.
+ *
+ * 2) The size of the aligned portion of the array is a multiple of the minimum
+ *    architecture alignment required for DMA.
+ *
+ * 3) The aligned portion contains enough space for the original number of
+ *    elements requested.
+ *
+ * The macro then creates a pointer to the aligned portion of this array and
+ * assigns to the pointer the address of the first element in the aligned
+ * portion of the array.
+ *
+ * Calling the macro as:
+ *
+ *     ALLOC_CACHE_ALIGN_BUFFER(uint32_t, buffer, 1024);
+ *
+ * Will result in something similar to saying:
+ *
+ *     uint32_t    buffer[1024];
+ *
+ * The following differences exist:
+ *
+ * 1) The resulting buffer is guaranteed to be aligned to the value of
+ *    ARCH_DMA_MINALIGN.
+ *
+ * 2) The buffer variable created by the macro is a pointer to the specified
+ *    type, and NOT an array of the specified type.  This can be very important
+ *    if you want the address of the buffer, which you probably do, to pass it
+ *    to the DMA hardware.  The value of &buffer is different in the two cases.
+ *    In the macro case it will be the address of the pointer, not the address
+ *    of the space reserved for the buffer.  However, in the second case it
+ *    would be the address of the buffer.  So if you are replacing hard coded
+ *    stack buffers with this macro you need to make sure you remove the & from
+ *    the locations where you are taking the address of the buffer.
+ *
+ * Note that the size parameter is the number of array elements to allocate,
+ * not the number of bytes.
+ *
+ * This macro can not be used outside of function scope, or for the creation
+ * of a function scoped static buffer.  It can not be used to create a cache
+ * line aligned global buffer.
+ */
+#define PAD_COUNT(s, pad) (((s) - 1) / (pad) + 1)
+#define PAD_SIZE(s, pad) (PAD_COUNT(s, pad) * pad)
+#define ALLOC_ALIGN_BUFFER_PAD(type, name, size, align, pad)		\
+	char __##name[ROUND(PAD_SIZE((size) * sizeof(type), pad), align)  \
+		      + (align - 1)];					\
+									\
+	type *name = (type *) ALIGN((uintptr_t)__##name, align)
+#define ALLOC_ALIGN_BUFFER(type, name, size, align)		\
+	ALLOC_ALIGN_BUFFER_PAD(type, name, size, align, 1)
+#define ALLOC_CACHE_ALIGN_BUFFER_PAD(type, name, size, pad)		\
+	ALLOC_ALIGN_BUFFER_PAD(type, name, size, ARCH_DMA_MINALIGN, pad)
+#define ALLOC_CACHE_ALIGN_BUFFER(type, name, size)			\
+	ALLOC_ALIGN_BUFFER(type, name, size, ARCH_DMA_MINALIGN)
+
+/*
+ * DEFINE_CACHE_ALIGN_BUFFER() is similar to ALLOC_CACHE_ALIGN_BUFFER, but it's
+ * purpose is to allow allocating aligned buffers outside of function scope.
+ * Usage of this macro shall be avoided or used with extreme care!
+ */
+#define DEFINE_ALIGN_BUFFER(type, name, size, align)			\
+	static char __##name[roundup(size * sizeof(type), align)]	\
+			__aligned(align);				\
+									\
+	static type *name = (type *)__##name
+#define DEFINE_CACHE_ALIGN_BUFFER(type, name, size)			\
+	DEFINE_ALIGN_BUFFER(type, name, size, ARCH_DMA_MINALIGN)
+
 #endif	/* __COMMON_H_ */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/config_cmd_all.h u-boot-2011.06/include/config_cmd_all.h
--- u-boot-2011.06_original/include/config_cmd_all.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/include/config_cmd_all.h	2014-07-29 17:28:38.819972000 +0800
@@ -25,7 +25,7 @@
 #define CONFIG_CMD_CDP		/* Cisco Discovery Protocol	*/
 #define CONFIG_CMD_CONSOLE	/* coninfo			*/
 #define CONFIG_CMD_DATE		/* support for RTC, date/time...*/
-#define CONFIG_CMD_DHCP		/* DHCP Support			*/
+//#define CONFIG_CMD_DHCP		/* DHCP Support			*/
 #define CONFIG_CMD_DIAG		/* Diagnostics			*/
 #define CONFIG_CMD_DISPLAY	/* Display support		*/
 #define CONFIG_CMD_DOC		/* Disk-On-Chip Support		*/
@@ -61,12 +61,12 @@
 #define CONFIG_CMD_MMC		/* MMC support			*/
 #define CONFIG_CMD_MTDPARTS	/* mtd parts support		*/
 #define CONFIG_CMD_NAND		/* NAND support			*/
-#define CONFIG_CMD_NET		/* bootp, tftpboot, rarpboot	*/
-#define CONFIG_CMD_NFS		/* NFS support			*/
+//#define CONFIG_CMD_NET		/* bootp, tftpboot, rarpboot	*/
+//#define CONFIG_CMD_NFS		/* NFS support			*/
 #define CONFIG_CMD_ONENAND	/* OneNAND support		*/
 #define CONFIG_CMD_PCI		/* pciinfo			*/
 #define CONFIG_CMD_PCMCIA	/* PCMCIA support		*/
-#define CONFIG_CMD_PING		/* ping support			*/
+//#define CONFIG_CMD_PING		/* ping support			*/
 #define CONFIG_CMD_PORTIO	/* Port I/O			*/
 #define CONFIG_CMD_REGINFO	/* Register dump		*/
 #define CONFIG_CMD_REISER	/* Reiserfs support		*/
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/config_cmd_default.h u-boot-2011.06/include/config_cmd_default.h
--- u-boot-2011.06_original/include/config_cmd_default.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/include/config_cmd_default.h	2014-07-29 17:28:38.819972000 +0800
@@ -32,8 +32,8 @@
 #define CONFIG_CMD_LOADS	/* loads			*/
 #define CONFIG_CMD_MEMORY	/* md mm nm mw cp cmp crc base loop mtest */
 #define CONFIG_CMD_MISC		/* Misc functions like sleep etc*/
-#define CONFIG_CMD_NET		/* bootp, tftpboot, rarpboot	*/
-#define CONFIG_CMD_NFS		/* NFS support			*/
+//#define CONFIG_CMD_NET		/* bootp, tftpboot, rarpboot	*/
+//#define CONFIG_CMD_NFS		/* NFS support			*/
 #define CONFIG_CMD_RUN		/* run command in env variable	*/
 #define CONFIG_CMD_SAVEENV	/* saveenv			*/
 #define CONFIG_CMD_SETGETDCR	/* DCR support on 4xx		*/
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/config_defaults.h u-boot-2011.06/include/config_defaults.h
--- u-boot-2011.06_original/include/config_defaults.h	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/include/config_defaults.h	2014-07-29 17:28:38.819972000 +0800
@@ -17,4 +17,8 @@
 #define CONFIG_GZIP 1
 #define CONFIG_ZLIB 1
 
+#define CONFIG_RSAVERIFY 1
+#define CONFIG_MD5 1
+#define CONFIG_SHA256 1
+
 #endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/config_polarssl.h u-boot-2011.06/include/config_polarssl.h
--- u-boot-2011.06_original/include/config_polarssl.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/config_polarssl.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,47 @@
+/**
+ * \file config.h
+ *
+ * \brief Configuration options (set of defines)
+ *
+ *  Copyright (C) 2006-2014, Brainspark B.V.
+ *
+ *  This file is part of PolarSSL (http://www.polarssl.org)
+ *  Lead Maintainer: Paul Bakker <polarssl_maintainer at polarssl.org>
+ *
+ *  All rights reserved.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License along
+ *  with this program; if not, write to the Free Software Foundation, Inc.,
+ *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * This set of compile-time options may be used to enable
+ * or disable features selectively, and reduce the global
+ * memory footprint.
+ */
+#ifndef POLARSSL_CONFIG_H
+#define POLARSSL_CONFIG_H
+
+#define POLARSSL_HAVE_INT32
+#define POLARSSL_HAVE_ASM
+#define POLARSSL_PKCS1_V21
+#define POLARSSL_PKCS1_V15
+#define POLARSSL_RSA_C
+#define POLARSSL_BIGNUM_C
+#define POLARSSL_SHA256_C
+#define POLARSSL_MD_C
+#define POLARSSL_ASN1_PARSE_C
+#define POLARSSL_OID_C
+
+typedef unsigned int size_t;
+
+#endif /* POLARSSL_CONFIG_H */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/configs/cnc1900.h u-boot-2011.06/include/configs/cnc1900.h
--- u-boot-2011.06_original/include/configs/cnc1900.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/configs/cnc1900.h	2015-08-20 19:25:54.678159000 +0800
@@ -0,0 +1,283 @@
+/*
+ * (C) Copyright 2012
+ *  Cavium Xiaodong.Fan
+ * Configuration settings for the "CNC1900 FPGA Board",
+ * the evaluation board for the Nomadik 8815 System on Chip.
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#ifndef __CONFIG_H
+#define __CONFIG_H
+
+#define CONFIG_ARMV7
+#define CONFIG_ARCH_CNC1900
+#define CONFIG_256M_DDR
+
+/* commands */
+#include <config_cmd_default.h>
+
+#define CONFIG_L2_OFF 1
+
+#undef CONFIG_CMD_FLASH
+#undef CONFIG_CMD_IMLS
+#define CONFIG_SYS_NO_FLASH
+#define CONFIG_CMD_LOADB
+#define CONFIG_CMD_MEMORY
+#define CONFIG_CMD_CACHE
+
+#define CONFIG_CMD_BOOTS
+#define CONFIG_CMD_ESP1800L_FLASH_UTIL
+
+#define CONFIG_CMD_CSLOGO
+
+/* i2c */
+#define CONFIG_CNC1900_I2C
+#define CONFIG_CMD_I2C
+#define CONFIG_HARD_I2C
+#define CONFIG_SYS_I2C_SPEED	100000
+#define CONFIG_SYS_I2C_SLAVE    0x7f
+#define CONFIG_SYS_I2C_BASE     0x80170000
+#define CONFIG_SYS_I2C_CLK      CONFIG_SYS_PCLK_FREQ
+
+#if defined(CONFIG_CNC1900_I2C)
+#define CONFIG_CMD_EEPROM
+#endif
+
+#define CONFIG_CMD_GPIO
+#define CONFIG_CNC1900_GPIO
+#define CNC1900_GPIO_BASE      0x80260000
+#define REG_GPIO_SWPORTA_DDR 0x24
+#define REG_GPIO_SWPORTB_DDR 0x38
+#define REG_GPIO_EXT_PORTA   0x60
+#define REG_GPIO_EXT_PORTB   0x64
+#define REG_GPIO_SWPORTA_DR  0x20
+#define REG_GPIO_SWPORTB_DR  0x34
+
+/* user interface */
+#define CONFIG_CNC1900_CRYPTO
+#define CONFIG_CMD_CNC1900_OTP
+
+//#define DEBUG
+#define CONFIG_SYS_LONGHELP
+#define CONFIG_SYS_HUSH_PARSER
+#define CONFIG_SYS_PROMPT		"CNC1900> "
+#define CONFIG_SYS_PROMPT_HUSH_PS2	"> "
+#define CONFIG_CMDLINE_EDITING
+#define CONFIG_SYS_CBSIZE		512	/* Console I/O Buffer Size */
+#define CONFIG_SYS_PBSIZE		(CONFIG_SYS_CBSIZE \
+					+ sizeof(CONFIG_SYS_PROMPT) + 16)
+#define CONFIG_SYS_BARGSIZE	CONFIG_SYS_CBSIZE /* Boot Arg Buffer Size */
+#define CONFIG_SYS_MAXARGS	    16
+#define CONFIG_SYS_LOAD_ADDR	0x800000	/* default load address */
+#define CONFIG_SYS_LOADS_BAUD_CHANGE
+
+/* polarssl config */
+#define POLARSSL_CONFIG_FILE "config_polarssl.h"
+
+/* boot config */
+#define CONFIG_SETUP_MEMORY_TAGS
+#define CONFIG_INITRD_TAG
+#define CONFIG_CMDLINE_TAG
+#define CONFIG_BOOTDELAY 1
+#define CONFIG_AUTO_COMPLETE
+#define CONFIG_ZERO_BOOTDELAY_CHECK
+
+/*sd/mmc slot */
+#define CONFIG_DWMMC
+#define CONFIG_CNC_DWMMC
+#define CONFIG_MMC
+#define CONFIG_CMD_MMC
+#define CONFIG_GENERIC_MMC
+
+/* GPT */
+#define HAVE_BLOCK_DEVICE
+#define CONFIG_PARTITION_UUIDS
+#define CONFIG_EFI_PARTITION
+#define CONFIG_CMD_GPT
+
+/* Simg */
+#define CONFIG_CMD_SIMG
+
+/* eeprom */
+#if defined(CONFIG_CMD_EEPROM)
+#define CONFIG_SYS_I2C_EEPROM_ADDR            0x50
+#define CONFIG_SYS_I2C_EEPROM_ADDR_LEN        2
+#define CONFIG_ETHADDR_EEPROM_OFFSET          0x114
+#endif
+
+/* memory-related information */
+#define CONFIG_NR_DRAM_BANKS	1
+#define PHYS_SDRAM_1		0x00000000	/* DDR-SDRAM Bank #1 */
+#ifdef DDR_SIZE_1G
+#define PHYS_SDRAM_1_SIZE       0x40000000      /* 1G MB */
+#elif defined DDR_SIZE_512M
+#define PHYS_SDRAM_1_SIZE	0x10000000	/* 512 MB */
+#else
+#define PHYS_SDRAM_1_SIZE	0x10000000	/* 256 MB */
+#endif
+
+#define CONFIG_SYS_SDRAM_BASE	    PHYS_SDRAM_1
+#define CONFIG_SYS_SDRAM_SIZE	    PHYS_SDRAM_1_SIZE
+#define CONFIG_SYS_TEXT_BASE        0x2000000
+#define CONFIG_SYS_PHY_UBOOT_BASE   CONFIG_SYS_TEXT_BASE
+#define CONFIG_SYS_INIT_SP_ADDR     (CONFIG_SYS_TEXT_BASE - CONFIG_SYS_MALLOC_LEN - 512)
+
+#define CONFIG_SYS_MEM_TOP_HIDE     (0x4100000) /* 65MB */
+#define CONFIG_STACKSIZE	        (512 * 1024)	/* regular stack */
+
+#define CONFIG_USE_IRQ
+#ifdef CONFIG_USE_IRQ
+#define CONFIG_STACKSIZE_IRQ	(4 * 1024)	/* IRQ stack */
+#define CONFIG_STACKSIZE_FIQ	(4 * 1024)	/* FIQ stack */
+#endif
+
+#define CONFIG_SYS_MEMTEST_START	0x00000000
+#define CONFIG_SYS_MEMTEST_END		0x0FFFFFFF
+#define CONFIG_SYS_MALLOC_LEN		(CONFIG_ENV_SIZE + 12 * 1024 * 1024)
+
+/* timing informazion */
+#define CONFIG_SYS_PCLK_FREQ        CONFIG_SYS_CPU_CLK
+#define CONFIG_SYS_HZ		        1000
+
+
+#define CONFIG_SYS_NS16550
+#define CONFIG_SYS_NS16550_SERIAL
+#define CONFIG_CONS_INDEX	          1
+#define CONFIG_SYS_NS16550_REG_SIZE   (-4)
+#define CONFIG_BAUDRATE		          115200
+#define CONFIG_SYS_BAUDRATE_TABLE	  { 9600, 19200, 38400, 57600, 115200 }
+#define CONFIG_SYS_NS16550_COM1       0x801F1000
+#define CONFIG_SYS_NS16550_COM2       0x801F2000
+
+/* NAND */
+#define CONFIG_CMD_NAND
+#define CONFIG_CNC_NAND
+#define CONFIG_CNC_NAND_BASE    0x80100000
+#define CONFIG_SYS_NAND_BASE	0xA4000000
+#define CONFIG_SYS_MAX_NAND_DEVICE	1
+
+/* ETH */
+#define CONFIG_NET_MULTI
+#define CONFIG_CMD_NET
+#define CONFIG_CMD_PING
+#define CONFIG_CMD_DHCP
+#define CONFIG_CN100_BASEADDRESS	0xb1400000
+
+/* EHCI */
+#define CONFIG_CMD_FAT
+#define CONFIG_CMD_USB
+#define CONFIG_USB_EHCI
+#define CONFIG_USB_EHCI_CNC
+#define CONFIG_SYS_USB_EHCI_REGS_BASE	    0x80200000
+#define CONFIG_SYS_USB_EHCI_MAX_ROOT_PORTS  2
+#define CONFIG_DOS_PARTITION
+#define CONFIG_LBA48
+#define CONFIG_USB_STORAGE
+#define CONFIG_AUTO_UPDATE
+
+/* environment */
+#define CONFIG_CMD_SAVEENV
+#define CONFIG_ENV_OVERWRITE
+
+#define CONFIG_CMD_ANDR_BOOT
+#define CONFIG_CMD_AUTO_BOOT
+
+
+/* Legacy SPI flash commands, will remove later */
+#if 0
+#define CONFIG_SPI_FLASH_CNC1900
+#define CONFIG_CMD_SF_LEGACY
+#endif
+
+#define  SPI_TOKEN  "cnc-spi"
+
+/* New SPI driver */
+#define CONFIG_CMD_SF
+#define CONFIG_DW_SPI
+#define CONFIG_CMD_SPI
+#define CONFIG_SPI_FLASH
+#define CONFIG_SPI_FLASH_MACRONIX
+#define CONFIG_SPI_FLASH_WINBOND
+#define CONFIG_SPI_FLASH_GIGADEVICE
+#define CONFIG_CMD_SF
+#define CONFIG_SF_DEFAULT_SPEED 25000000
+
+
+/* reserve 10M for u-boot self, log buf, TLB, bd_t, irq stack, abort stack and so on */
+#ifdef CONFIG_SYS_MEM_TOP_HIDE
+    /*
+     * Ethernet DMA buffer can only use memory less than 256MiB,
+     * so use 256MiB instead of 512MiB as base address on 512MiB RAM board
+     */
+    #if (PHYS_SDRAM_1_SIZE >= 0x10000000)
+        #define CONFIG_MEM_DEFINE_BASE  (0x10000000 - CONFIG_SYS_MEM_TOP_HIDE - CONFIG_SYS_MALLOC_LEN - 0xa00000)
+	 #define CONFIG_USB_UPGRADE_DATA_ADDR 	(0x10000000)
+    #else
+        #define CONFIG_MEM_DEFINE_BASE  (PHYS_SDRAM_1_SIZE - CONFIG_SYS_MEM_TOP_HIDE - CONFIG_SYS_MALLOC_LEN - 0xa00000)
+	 #define CONFIG_USB_UPGRADE_DATA_ADDR 	(0x1000000)
+    #endif
+#else
+    #if (PHYS_SDRAM_1_SIZE >= 0x10000000)
+        #define CONFIG_MEM_DEFINE_BASE  (0x10000000 - CONFIG_SYS_MALLOC_LEN - 0xa00000)
+	 #define CONFIG_USB_UPGRADE_DATA_ADDR 	(0x10000000)
+    #else
+        #define CONFIG_MEM_DEFINE_BASE  (PHYS_SDRAM_1_SIZE - CONFIG_SYS_MALLOC_LEN - 0xa00000)
+	 #define CONFIG_USB_UPGRADE_DATA_ADDR 	(0x1000000)
+    #endif
+#endif
+
+#define CONFIG_UBOOT_EXTERNAL_PROC_LEN (0x100000) //for PIC processes code such as hdmi or OTA that will be combined after u-boot.bin
+
+#define CONFIG_SPI_DMA_BUF_LEN 0x800000
+#define CONFIG_SPI_DMA_BUF_BASE (CONFIG_MEM_DEFINE_BASE - CONFIG_SPI_DMA_BUF_LEN)
+
+#define CONFIG_XPORT_MEM_LEN 0x800000
+#define CONFIG_XPORT_MEM_BASE (CONFIG_SPI_DMA_BUF_BASE - CONFIG_XPORT_MEM_LEN)
+#define CRYPTO_MEM_SIZE 0x300000
+#define CRYPTO_MEM_REGION (CONFIG_XPORT_MEM_BASE - CRYPTO_MEM_SIZE)
+#define CONFIG_ALIGNED_PIC_PROC_MEM_SIZE CONFIG_UBOOT_EXTERNAL_PROC_LEN
+#define CONFIG_ALIGNED_PIC_PROC_MEM_BASE (((CRYPTO_MEM_REGION - CONFIG_ALIGNED_PIC_PROC_MEM_SIZE-sizeof(int))+(sizeof(int)-1))&(0xFFFFFFFC))
+
+/* this is needed to make hello_world.c and other stuff happy */
+#define CONFIG_SYS_MAX_FLASH_SECT	512
+#define CONFIG_SYS_MAX_FLASH_BANKS	1
+
+#include <config_target_specific.h>
+
+#define CONFIG_CNC1900_SD0_BASE  0x80290000  /* Mobile Storage Host Controller (MMC/SD/SDIO) */
+#define CONFIG_CNC1900_SD1_BASE  0x802a0000  /* Mobile Storage Host Controller (MMC/SD/SDIO) */
+
+#define CONFIG_PARTITIONS
+#define CONFIG_DOS_PARTITION
+
+#define CONFIG_CMD_CALL_EXTERNAL_PROC
+#define CONFIG_CMD_UPGRADE
+
+#define CONFIG_SYS_CONSOLE_INFO_QUIET
+
+#define CONFIG_CNC1900_DF
+#define CONFIG_CMD_CNC1900_AUDIO
+/** System Cotrol */
+#define CNC1900_SYSCTL_BASE             0xB2000000
+/* Pin Mux */
+#define CNC1900_PIN_MUX                 (CNC1900_SYSCTL_BASE + 0x00110000)
+#define BOARD_LATE_INIT
+
+#endif /* __CONFIG_H */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/configs/orion.h u-boot-2011.06/include/configs/orion.h
--- u-boot-2011.06_original/include/configs/orion.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/configs/orion.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,209 @@
+/*
+ * (C) Copyright 2005
+ * STMicroelectronics.
+ * Configuration settings for the "Nomadik Hardware Kit" NHK-8815,
+ * the evaluation board for the Nomadik 8815 System on Chip.
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#ifndef __CONFIG_H
+#define __CONFIG_H
+
+#define CONFIG_ARM926EJS
+#define CONFIG_ARCH_CSM1800
+#define CONFIG_256M_DDR
+
+#define CONFIG_SKIP_LOWLEVEL_INIT /* we have already been loaded to RAM */
+
+/* commands */
+#include <config_cmd_default.h>
+
+#define CONFIG_CMD_NET
+#define CONFIG_CMD_PING
+#define CONFIG_CMD_DHCP
+#define CONFIG_CMD_NFS
+/* There is no NOR flash, so undefine these commands */
+#undef CONFIG_CMD_FLASH
+#undef CONFIG_CMD_IMLS
+#define CONFIG_SYS_NO_FLASH
+/* There is NAND storage */
+//#define CONFIG_NAND_NOMADIK
+#define CONFIG_CMD_JFFS2
+/* There is EEPROM storage */
+#define CONFIG_CMD_EEPROM
+
+/* user interface */
+#define CONFIG_SYS_LONGHELP
+#define CONFIG_SYS_HUSH_PARSER
+#define CONFIG_SYS_PROMPT		"CSM1800h> "
+#define CONFIG_SYS_PROMPT_HUSH_PS2	"> "
+#define CONFIG_CMDLINE_EDITING
+#define CONFIG_SYS_CBSIZE		256	/* Console I/O Buffer Size */
+#define CONFIG_SYS_PBSIZE		(CONFIG_SYS_CBSIZE \
+					+ sizeof(CONFIG_SYS_PROMPT) + 16)
+#define CONFIG_SYS_BARGSIZE	CONFIG_SYS_CBSIZE /* Boot Arg Buffer Size */
+#define CONFIG_SYS_MAXARGS	16
+#define CONFIG_SYS_LOAD_ADDR	0x800000	/* default load address */
+#define CONFIG_SYS_LOADS_BAUD_CHANGE
+
+/* boot config */
+#define CONFIG_SETUP_MEMORY_TAGS
+#define CONFIG_INITRD_TAG
+#define CONFIG_CMDLINE_TAG
+#define CONFIG_BOOTDELAY	1
+#define CONFIG_ETHADDR	00:12:57:5b:4c:ce
+#define CONFIG_SERVERIP	192.168.18.74
+#define CONFIG_IPADDR   192.168.18.117
+#define CONFIG_BOOTARGS	"root=/dev/ram0 console=ttyAMA1,115200n8 init=linuxrc"
+/*
+#define CONFIG_BOOTCOMMAND	"fsload 0x100000 kernel.uimg;" \
+				" fsload 0x800000 initrd.gz.uimg;" \
+				" bootm 0x100000 0x800000"
+*/
+
+/* memory-related information */
+#define CONFIG_NR_DRAM_BANKS	1
+#define PHYS_SDRAM_1		0x00000000	/* DDR-SDRAM Bank #1 */
+#define PHYS_SDRAM_1_SIZE	0x10000000	/* 256 MB */
+//#define PHYS_SDRAM_2		0x08000000	/* SDR-SDRAM BANK #2*/
+//#define PHYS_SDRAM_2_SIZE	0x04000000	/* 64 MB */
+#define CONFIG_SYS_SDRAM_BASE	PHYS_SDRAM_1
+#define CONFIG_SYS_SDRAM_SIZE	PHYS_SDRAM_1_SIZE
+#define CONFIG_SYS_TEXT_BASE        0x2000000
+#define CONFIG_SYS_PHY_UBOOT_BASE   CONFIG_SYS_TEXT_BASE
+#define CONFIG_SYS_INIT_SP_ADDR (CONFIG_SYS_TEXT_BASE - CONFIG_SYS_MALLOC_LEN - 512)
+
+#define CONFIG_STACKSIZE	(512 * 1024)	/* regular stack */
+
+#define CONFIG_USE_IRQ
+#ifdef CONFIG_USE_IRQ
+#  define CONFIG_STACKSIZE_IRQ	(4 * 1024)	/* IRQ stack */
+#  define CONFIG_STACKSIZE_FIQ	(4 * 1024)	/* FIQ stack */
+#endif
+
+#define CONFIG_SYS_MEMTEST_START	0x00000000
+#define CONFIG_SYS_MEMTEST_END		0x0FFFFFFF
+#define CONFIG_SYS_MALLOC_LEN		(CONFIG_ENV_SIZE + 12 * 1024 * 1024)
+
+/* timing informazion */
+#define CONFIG_SYS_CPU_CLK              378000000
+#define CONFIG_SYS_PCLK_FREQ            (CONFIG_SYS_CPU_CLK / 8)
+#define CONFIG_SYS_HZ		        1000
+#define CONFIG_SYS_TIMERBASE	        0x101E2000
+#define CONFIG_SYS_TIMER_INTERVAL       10000
+#define CONFIG_SYS_TIMER_RELOAD         (CONFIG_SYS_TIMER_INTERVAL >> 4)  /* Divide by 16 */
+#define CONFIG_SYS_TIMER_CTRL          0x84                              /* Enable, Clock / 16 */
+
+/* usb */
+#define CONFIG_CMD_FAT
+#define CONFIG_CMD_USB
+
+#define CONFIG_USB_OHCI_NEW
+#define CONFIG_SYS_USB_OHCI_REGS_BASE        0x80210000
+#define CONFIG_SYS_USB_OHCI_SLOT_NAME        "CSM1800H"
+#define CONFIG_SYS_USB_OHCI_MAX_ROOT_PORTS   1
+#define CONFIG_DOS_PARTITION
+#define CONFIG_USB_CSM
+#define CONFIG_USB_STORAGE
+
+#define CONFIG_SYS_NS16550
+#define CONFIG_SYS_NS16550_SERIAL
+#define CONFIG_SYS_NS16550_CLK          CONFIG_SYS_PCLK_FREQ
+#define CONFIG_CONS_INDEX	        1
+#define CONFIG_SYS_NS16550_REG_SIZE     (-4)
+#define CONFIG_BAUDRATE		        115200
+#define CONFIG_SYS_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }
+#define CONFIG_SYS_NS16550_COM1         0x101F1000
+#define CONFIG_SYS_NS16550_COM2         0x101F2000
+
+/* i2c */
+#define CONFIG_ORION_I2C
+#define CONFIG_CMD_I2C
+#define CONFIG_HARD_I2C
+#define CONFIG_SYS_I2C_SPEED	100000
+#define CONFIG_SYS_I2C_SLAVE    0x7f
+#define CONFIG_SYS_I2C_BASE     0x10170000
+#define CONFIG_SYS_I2C_CLK      CONFIG_SYS_PCLK_FREQ
+
+#define CONFIG_CMD_GPIO
+#define CONFIG_ORION_GPIO
+#define ORION_GPIO_BASE      0x10260000
+#define REG_GPIO_SWPORTA_DDR 0x24
+#define REG_GPIO_SWPORTB_DDR 0x38
+#define REG_GPIO_EXT_PORTA   0x60
+#define REG_GPIO_EXT_PORTB   0x64
+#define REG_GPIO_SWPORTA_DR  0x20
+#define REG_GPIO_SWPORTB_DR  0x34
+
+/* eeprom */
+#if defined(CONFIG_CMD_EEPROM)
+#define CONFIG_SYS_I2C_EEPROM_ADDR            0x50
+#define CONFIG_SYS_I2C_EEPROM_ADDR_LEN        2
+#define CONFIG_ORION_ETHADDR_EEPROM_OFFSET    0x114
+#endif
+
+#define CONFIG_DRIVER_CN100
+#define CN100_BASEADDRESS			0x41400000
+#define CONFIG_BOOTFILE		"uImage"
+
+#define CONFIG_IP_DEFRAG	/* Allows faster download, TFTP and NFS */
+//#define CONFIG_TFTP_BLOCKSIZE	4096
+#define CONFIG_NFS_READ_SIZE	4096
+
+//#define CONFIG_CMD_NAND
+//#define CONFIG_SYS_MAX_NAND_DEVICE	1
+//#define CONFIG_SYS_NAND_BASE		0x40000000 /* SMPS0n */
+
+#define CONFIG_CMD_SAVEENV
+
+#if defined (CONFIG_ARCH_CSM_NAND_BOOT)
+
+#define CONFIG_ENV_IS_IN_NAND
+#define CONFIG_ENV_SIZE          0x00020000 /* Total Size of Environment Sector 128KB(for 2k pagesize of csm1800) */
+#define CONFIG_ENV_OFFSET        0x00060000 /* environment starts here/aligned with 128KB                         */
+#define CONFIG_ENV_SECT_SIZE     0x00020000 /* 64 KB sectors                                                      */
+
+#else
+
+#define CONFIG_ENV_IS_IN_SPI_FLASH
+#define CONFIG_ENV_OVERWRITE
+#define CONFIG_ENV_SIZE          0x00010000 /* Total Size of Environment Sector 64KB */
+#define CONFIG_ENV_OFFSET        0x00050000 /* environment starts here               */
+#define CONFIG_ENV_SECT_SIZE     0x00010000 /* 64 KB sectors                         */
+
+#endif
+
+
+//#define CONFIG_SPI_FLASH
+#define CONFIG_SPI_FLASH_ORION
+#define CONFIG_CMD_SF
+
+//#define CONFIG_CMD_SPI
+//#define CONFIG_ORION_SPI
+//#define CONFIG_SYS_SPI_BASE             0x10150000
+
+/* this is needed to make hello_world.c and other stuff happy */
+#define CONFIG_SYS_MAX_FLASH_SECT	512
+#define CONFIG_SYS_MAX_FLASH_BANKS	1
+
+#define CONFIG_CSM1800H_XPORT
+#define CONFIG_XPORT_BASE (0x41400000) 
+#define CONFIG_CSM1800H_TUNER
+#endif /* __CONFIG_H */
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/config_target_names.h u-boot-2011.06/include/config_target_names.h
--- u-boot-2011.06_original/include/config_target_names.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/config_target_names.h	2015-03-16 11:19:40.877878000 +0800
@@ -0,0 +1,14 @@
+#ifndef _CONFIG_TARGET_NAMES_
+#define _CONFIG_TARGET_NAMES_
+
+#define CNC1900_EVB           0
+#define CNC1900_HDK           1
+#define CNC1900_FJ_RX         2
+#define CNC1900_FPGA          3
+#define CNC1900_ZINWELL       4
+#define CNW83XX_OTT_EMMC      5
+#define CNW83XX_VMS_MINI      6
+#define CNW83XX_SONY          7
+#define CNW83XX_SONY_VEDETT   8
+#endif
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/config_target_specific.h u-boot-2011.06/include/config_target_specific.h
